/*
 * This file is part of ClanBomber;
 * you can get it at "http://www.nongnu.org/clanbomber".
 *
 * Copyright (C) 2009, 2010 Rene Lopez <rsl@members.fsf.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#include "AudioBufferSDL.h"

namespace cbe
{
  AudioBufferSDL::AudioBufferSDL(boost::filesystem::path filename)
  {
    chunk = Mix_LoadWAV(filename.string().c_str());
    if(chunk == NULL) {
      printf("Cannot load sound file");
      //TODO launch an exception
    }
  }

  AudioBufferSDL::~AudioBufferSDL()
  {
    Mix_FreeChunk(chunk);
  }

  void AudioBufferSDL::play()
  {
    Mix_PlayChannel(-1, chunk, 0);
  }
};
